-- compteur decimal a nombre arbitraire de decades par utilisation
-- des decades elementaires dans une architecture structurelle.


use work.decimal.all; -- contient la description d'une decade, fichier
		      -- decade.vhd a compiler en meme temps ou avant.

entity cntdec is
   generic ( taille : integer := 2 ) ; 
   -- permet de fixer le nombre de decades, 2 par defaut
   port ( clk, en, zero : in bit ;
      sortie : out nombre (taille-1 downto 0) ;
      carry  : out bit) ;
end cntdec ;

architecture struct of cntdec is
   signal retenue : bit_vector (taille-1 downto 0) ;
begin
   ci : for i in 0 to taille - 1 generate
      c0 : if i = 0 generate
--         for ci0 : decade use entity work.decade(vecteur) ;
         ci0 : decade port map (clk,en,zero,sortie(i),retenue(i)) ;
      end generate c0 ;
      cn : if i > 0 generate
--         for cin : decade use entity work.decade(surcharge) ;
         cin : decade port map (clk,retenue(i-1),zero,sortie(i),retenue(i)) ;
      end generate cn ;
   end generate ci ;
   carry <= retenue(taille-1) ;
end struct ;

architecture multibloc of cntdec is
   signal retenue : bit_vector (taille downto 0) ;
begin
   retenue(0) <= en ;
   carry <= retenue(taille) ;
   ci : for i in 0 to taille - 1 generate
         signal countTemp: chiffre ;
   begin
      sortie(i)  <= countTemp ;
      retenue(i + 1) <= retenue(i) when countTemp = 9 else '0' ;
      incre : PROCESS
      BEGIN
         WAIT UNTIL (clk = '1') ;
         if (zero = '1') then
            countTemp <= 0 ;
         elsif (retenue(i) = '1') then
            countTemp <= countTemp + 1 ;  
         end if ;
      END process incre ;
   end generate ci ;
end multibloc ;


